From cc438a3fb50835d29ea2995e0372a70051be452d Mon Sep 17 00:00:00 2001
From: Masahiko Sawada <sawada.mshk@gmail.com>
Date: Mon, 10 May 2021 20:32:25 +0900
Subject: [PATCH v37 3/9] Support two-phase commit for foreign transactions.

Co-authored-by: Masahiko Sawada, Ashutosh Bapat
---
 .../postgres_fdw/expected/postgres_fdw.out    |    2 +-
 src/backend/access/rmgrdesc/Makefile          |    1 +
 src/backend/access/rmgrdesc/fdwxactdesc.c     |   59 +
 src/backend/access/rmgrdesc/xlogdesc.c        |    4 +-
 src/backend/access/transam/Makefile           |    2 +
 src/backend/access/transam/fdwxact.c          | 1945 ++++++++++++++++-
 src/backend/access/transam/fdwxact_launcher.c |  587 +++++
 src/backend/access/transam/fdwxact_resolver.c |  339 +++
 src/backend/access/transam/rmgr.c             |    1 +
 src/backend/access/transam/twophase.c         |   35 +
 src/backend/access/transam/xact.c             |    4 +-
 src/backend/access/transam/xlog.c             |   41 +-
 src/backend/catalog/dependency.c              |    5 +-
 src/backend/catalog/system_views.sql          |    3 +
 src/backend/commands/dbcommands.c             |   14 +
 src/backend/commands/foreigncmds.c            |   78 +-
 src/backend/foreign/foreign.c                 |    6 +
 src/backend/nodes/copyfuncs.c                 |   15 +
 src/backend/nodes/equalfuncs.c                |   14 +
 src/backend/parser/gram.y                     |   29 +-
 src/backend/postmaster/bgworker.c             |    8 +
 src/backend/postmaster/postmaster.c           |   13 +-
 src/backend/replication/logical/decode.c      |    1 +
 src/backend/replication/syncrep.c             |   14 +-
 src/backend/storage/ipc/ipci.c                |    6 +
 src/backend/storage/ipc/procarray.c           |   42 +-
 src/backend/storage/lmgr/lwlocknames.txt      |    2 +
 src/backend/tcop/postgres.c                   |   16 +
 src/backend/tcop/utility.c                    |   12 +-
 src/backend/utils/activity/wait_event.c       |   15 +
 src/backend/utils/misc/guc.c                  |   48 +
 src/backend/utils/misc/postgresql.conf.sample |   14 +
 src/bin/initdb/initdb.c                       |    1 +
 src/bin/pg_controldata/pg_controldata.c       |    2 +
 src/bin/pg_resetwal/pg_resetwal.c             |    2 +
 src/bin/pg_waldump/rmgrdesc.c                 |    1 +
 src/include/access/fdwxact.h                  |   88 +-
 src/include/access/fdwxact_launcher.h         |   29 +
 src/include/access/fdwxact_resolver.h         |   22 +
 src/include/access/fdwxact_xlog.h             |   49 +
 src/include/access/resolver_internal.h        |   59 +
 src/include/access/rmgrlist.h                 |    1 +
 src/include/access/twophase.h                 |    1 +
 src/include/access/xlog_internal.h            |    1 +
 src/include/catalog/pg_control.h              |    1 +
 src/include/catalog/pg_proc.dat               |   23 +
 src/include/commands/defrem.h                 |    2 +
 src/include/foreign/fdwapi.h                  |    2 +
 src/include/nodes/nodes.h                     |    1 +
 src/include/nodes/parsenodes.h                |   10 +-
 src/include/replication/syncrep.h             |    2 +-
 src/include/storage/procarray.h               |    1 +
 src/include/utils/guc_tables.h                |    2 +
 src/include/utils/wait_event.h                |    7 +-
 src/test/regress/expected/rules.out           |    8 +
 55 files changed, 3623 insertions(+), 67 deletions(-)
 create mode 100644 src/backend/access/rmgrdesc/fdwxactdesc.c
 create mode 100644 src/backend/access/transam/fdwxact_launcher.c
 create mode 100644 src/backend/access/transam/fdwxact_resolver.c
 create mode 100644 src/include/access/fdwxact_launcher.h
 create mode 100644 src/include/access/fdwxact_resolver.h
 create mode 100644 src/include/access/fdwxact_xlog.h
 create mode 100644 src/include/access/resolver_internal.h

diff --git a/src/backend/access/rmgrdesc/Makefile b/src/backend/access/rmgrdesc/Makefile
index f88d72fd86..982c1a36cc 100644
--- a/src/backend/access/rmgrdesc/Makefile
+++ b/src/backend/access/rmgrdesc/Makefile
@@ -13,6 +13,7 @@ OBJS = \
 	clogdesc.o \
 	committsdesc.o \
 	dbasedesc.o \
+	fdwxactdesc.o \
 	genericdesc.o \
 	gindesc.o \
 	gistdesc.o \
diff --git a/src/backend/access/rmgrdesc/fdwxactdesc.c b/src/backend/access/rmgrdesc/fdwxactdesc.c
new file mode 100644
index 0000000000..4e97486640
--- /dev/null
+++ b/src/backend/access/rmgrdesc/fdwxactdesc.c
@@ -0,0 +1,59 @@
+/*-------------------------------------------------------------------------
+ *
+ * fdwxactdesc.c
+ *		rmgr descriptor routines for access/transam/fdwxact.c
+ *
+ * This module describes the WAL records for foreign transaction manager.
+ *
+ * Portions Copyright (c) 2021, PostgreSQL Global Development Group
+ *
+ * src/backend/access/rmgrdesc/fdwxactdesc.c
+ *
+ *-------------------------------------------------------------------------
+ */
+#include "postgres.h"
+
+#include "access/fdwxact_xlog.h"
+
+void
+fdwxact_desc(StringInfo buf, XLogReaderState *record)
+{
+	char	   *rec = XLogRecGetData(record);
+	uint8		info = XLogRecGetInfo(record) & ~XLR_INFO_MASK;
+
+	if (info == XLOG_FDWXACT_INSERT)
+	{
+		FdwXactStateOnDiskData *fdwxact_insert = (FdwXactStateOnDiskData *) rec;
+
+		appendStringInfo(buf, "xid: %u, dbid: %u, umid: %u, serverid: %u, owner: %u, identifier: %s",
+						 fdwxact_insert->xid,
+						 fdwxact_insert->dbid,
+						 fdwxact_insert->umid,
+						 fdwxact_insert->serverid,
+						 fdwxact_insert->owner,
+						 fdwxact_insert->identifier);
+	}
+	else
+	{
+		xl_fdwxact_remove *fdwxact_remove = (xl_fdwxact_remove *) rec;
+
+		appendStringInfo(buf, "xid: %u, umid: %u",
+						 fdwxact_remove->xid,
+						 fdwxact_remove->umid);
+	}
+
+}
+
+const char *
+fdwxact_identify(uint8 info)
+{
+	switch (info & ~XLR_INFO_MASK)
+	{
+		case XLOG_FDWXACT_INSERT:
+			return "NEW FOREIGN TRANSACTION";
+		case XLOG_FDWXACT_REMOVE:
+			return "REMOVE FOREIGN TRANSACTION";
+	}
+	/* Keep compiler happy */
+	return NULL;
+}
diff --git a/src/backend/access/rmgrdesc/xlogdesc.c b/src/backend/access/rmgrdesc/xlogdesc.c
index e6090a9dad..6bd3bb7700 100644
--- a/src/backend/access/rmgrdesc/xlogdesc.c
+++ b/src/backend/access/rmgrdesc/xlogdesc.c
@@ -112,12 +112,14 @@ xlog_desc(StringInfo buf, XLogReaderState *record)
 
 		appendStringInfo(buf, "max_connections=%d max_worker_processes=%d "
 						 "max_wal_senders=%d max_prepared_xacts=%d "
+						 "max_prepared_foreign_transactions=%d"
 						 "max_locks_per_xact=%d wal_level=%s "
-						 "wal_log_hints=%s track_commit_timestamp=%s",
+						 "wal_log_hints=%s track_commit_timestamp=%s ",
 						 xlrec.MaxConnections,
 						 xlrec.max_worker_processes,
 						 xlrec.max_wal_senders,
 						 xlrec.max_prepared_xacts,
+						 xlrec.max_prepared_foreign_xacts,
 						 xlrec.max_locks_per_xact,
 						 wal_level_str,
 						 xlrec.wal_log_hints ? "on" : "off",
diff --git a/src/backend/access/transam/Makefile b/src/backend/access/transam/Makefile
index b05a88549d..26a5ee589c 100644
--- a/src/backend/access/transam/Makefile
+++ b/src/backend/access/transam/Makefile
@@ -16,6 +16,8 @@ OBJS = \
 	clog.o \
 	commit_ts.o \
 	fdwxact.o \
+	fdwxact_launcher.o \
+	fdwxact_resolver.o \
 	generic_xlog.o \
 	multixact.o \
 	parallel.o \
diff --git a/src/backend/access/transam/fdwxact.c b/src/backend/access/transam/fdwxact.c
index ae3fdbdf83..0c6e80a6de 100644
--- a/src/backend/access/transam/fdwxact.c
+++ b/src/backend/access/transam/fdwxact.c
@@ -13,6 +13,57 @@
  * transaction manager calls corresponding FDW API to end the foreign
  * tranasctions.
  *
+ * To achieve commit among all foreign servers atomically, the global transaction
+ * manager supports two-phase commit protocol, which is a type of atomic commitment
+ * protocol. We WAL log the foreign transaction state so foreign transaction state
+ * is crash-safe.
+ *
+ * FOREIGN TRANSACTION RESOLUTION
+ *
+ * At PREPARE TRANSACTION, we prepare all transactions on foreign servers by executing
+ * PrepareForeignTransaction() API for each foreign transaction regardless of data on
+ * the foreign server having been modified.  At COMMIT PREPARED and ROLLBACK PREPARED,
+ * we commit or rollback only the local transaction but not do anything for involved
+ * foreign transactions.  The prepared foreign transactinos are resolved by a resolver
+ * process asynchronously.  Also, users can use pg_resolve_foreign_xact() SQL function
+ * that resolve a foreign transaction manually.
+ *
+ * LOCKING
+ *
+ * Whenever a foreign transaction is processed, the corresponding FdwXactState
+ * entry is updated. To avoid holding the lock during transaction processing
+ * which may take an unpredictable time the in-memory data of foreign
+ * transaction follows a locking model based on the following linked concepts:
+ *
+ * * A process who is going to work on the foreign transaction needs to set
+ *	 locking_backend of the FdwXactState entry, which prevents the entry from being
+ *	 updated and removed by concurrent processes.
+ * * All FdwXactState fields except for status are protected by FdwXactLock.  The
+ *   status is protected by its mutex.
+ *
+ * RECOVERY
+ *
+ * During replay WAL and replication FdwXactCtl also holds information about
+ * active prepared foreign transaction that haven't been moved to disk yet.
+ *
+ * Replay of fdwxact records happens by the following rules:
+ *
+ * * At the beginning of recovery, pg_fdwxacts is scanned once, filling FdwXactState
+ *	 with entries marked with fdwxact->inredo and fdwxact->ondisk.	FdwXactState file
+ *	 data older than the XID horizon of the redo position are discarded.
+ * * On PREPARE redo, the foreign transaction is added to FdwXactCtl->xacts.
+ *	 We set fdwxact->inredo to true for such entries.
+ * * On Checkpoint we iterate through FdwXactCtl->xacts entries that
+ *	 have fdwxact->inredo set and are behind the redo_horizon.	We save
+ *	 them to disk and then set fdwxact->ondisk to true.
+ * * On resolution we delete the entry from FdwXactCtl->xacts.  If
+ *	 fdwxact->ondisk is true, the corresponding entry from the disk is
+ *	 additionally deleted.
+ * * RecoverFdwXacts() and PrescanFdwXacts() have been modified to go through
+ *	 fdwxact->inredo entries that have not made it to disk.
+ *
+ * These replay rules are borrowed from twophase.c
+ *
  * Portions Copyright (c) 2021, PostgreSQL Global Development Group
  *
  * IDENTIFICATION
@@ -21,15 +72,42 @@
  */
 #include "postgres.h"
 
+#include <sys/types.h>
+#include <sys/stat.h>
+#include <unistd.h>
+
 #include "access/fdwxact.h"
+#include "access/fdwxact_resolver.h"
+#include "access/fdwxact_launcher.h"
 #include "access/xact.h"
 #include "access/xlog.h"
+#include "access/twophase.h"
+#include "access/resolver_internal.h"
+#include "access/xact.h"
+#include "access/xlog.h"
+#include "access/xloginsert.h"
+#include "access/xlogutils.h"
 #include "catalog/pg_user_mapping.h"
 #include "foreign/fdwapi.h"
 #include "foreign/foreign.h"
+#include "funcapi.h"
+#include "miscadmin.h"
+#include "pgstat.h"
+#include "replication/syncrep.h"
+#include "storage/ipc.h"
+#include "storage/latch.h"
+#include "storage/lock.h"
+#include "storage/procarray.h"
+#include "storage/sinvaladt.h"
+#include "utils/builtins.h"
+#include "utils/guc.h"
 #include "utils/memutils.h"
+#include "utils/rel.h"
 #include "utils/syscache.h"
 
+/* Directory where the foreign prepared transaction files will reside */
+#define FDWXACTS_DIR "pg_fdwxact"
+
 /* Initial size of the hash table */
 #define FDWXACT_HASH_SIZE	64
 
@@ -37,6 +115,23 @@
 #define ServerSupportTransactionCallback(fdwent) \
 	(((FdwXactEntry *)(fdwent))->commit_foreign_xact_fn != NULL)
 
+/* Check the FdwXactEntry is capable of two-phase commit  */
+#define ServerSupportTwophaseCommit(fdwent) \
+	(((FdwXactEntry *)(fdwent))->prepare_foreign_xact_fn != NULL)
+
+/*
+ * Name of foreign prepared transaction file is 8 bytes xid and
+ * user mapping OID separated by '_'.
+ *
+ * Since FdwXactState is identified by user mapping OID and it's unique
+ * within a distributed transaction, the name is fairly enough to
+ * ensure uniqueness.
+ */
+#define FDWXACT_FILE_NAME_LEN (8 + 1 + 8)
+#define FdwXactStateFilePath(path, xid, umid)	\
+	snprintf(path, MAXPGPATH, FDWXACTS_DIR "/%08X_%08X", \
+			 xid, umid)
+
 /*
  * Structure to bundle the foreign transaction participant.
  *
@@ -51,26 +146,146 @@ typedef struct FdwXactEntry
 	ForeignServer *server;
 	UserMapping *usermapping;
 
+	/*
+	 * Pointer to a FdwXactState entry in the global array. NULL if the entry
+	 * is not inserted yet but this is registered as a participant.
+	 */
+	FdwXactState fdwxact;
+
 	/* Callbacks for foreign transaction */
 	CommitForeignTransaction_function commit_foreign_xact_fn;
 	RollbackForeignTransaction_function rollback_foreign_xact_fn;
+	PrepareForeignTransaction_function prepare_foreign_xact_fn;
 } FdwXactEntry;
 
 /*
- * Foreign transaction participants involved in the current transaction.
- * A member of participants must support both commit and rollback APIs
+ * The current distributed transaction state.  Members of participants
+ * must support at least both commit and rollback APIs
  * (i.g., ServerSupportTransactionCallback() is true).
  */
-static HTAB *FdwXactParticipants = NULL;
+typedef struct DistributedXactStateData
+{
+	bool		local_prepared; /* will (did) we prepare the local transaction? */
+
+	/* Statistics of participants */
+	int			nparticipants_no_twophase;	/* how many participants doesn't
+											 * support two-phase commit
+											 * protocol? */
+
+	HTAB	   *participants;	/* foreign transaction participants (FdwXactEntry) */
+	List	   *serveroids_uniq;	/* list of unique server OIDs in
+									 * participants */
+} DistributedXactStateData;
+static DistributedXactStateData DistributedXactState = {
+	.local_prepared = false,
+	.nparticipants_no_twophase = 0,
+	.participants = NULL,
+	.serveroids_uniq = NIL,
+};
 
 /* Check the current transaction has at least one fdwxact participant */
 #define HasFdwXactParticipant() \
-	(FdwXactParticipants != NULL && \
-	 hash_get_num_entries(FdwXactParticipants) > 0)
+	(DistributedXactState.participants != NULL && \
+	 hash_get_num_entries(DistributedXactState.participants) > 0)
+
+/* Keep track of registering process exit call back. */
+static bool fdwXactExitRegistered = false;
+
+/* Guc parameter */
+int			max_prepared_foreign_xacts = 0;
+int			max_foreign_xact_resolvers = 0;
 
+static void RemoveFdwXactEntry(Oid umid);
 static void EndFdwXactEntry(FdwXactEntry *fdwent, bool isCommit,
 							bool is_parallel_worker);
-static void RemoveFdwXactEntry(Oid umid);
+static char *getFdwXactIdentifier(FdwXactEntry *fdwent, TransactionId xid);
+static void ForgetAllParticipants(void);
+static void FdwXactLaunchResolvers(void);
+
+static void PrepareAllFdwXacts(TransactionId xid);
+static XLogRecPtr FdwXactInsertEntry(TransactionId xid, FdwXactEntry *fdwent,
+									 char *identifier);
+static void AtProcExit_FdwXact(int code, Datum arg);
+static void FdwXactComputeRequiredXmin(void);
+static FdwXactStatus FdwXactGetTransactionFate(TransactionId xid);
+static void FdwXactRedoAdd(char *buf, XLogRecPtr start_lsn, XLogRecPtr end_lsn);
+static void FdwXactRedoRemove(TransactionId xid, Oid umid, bool givewarning);
+static void XlogReadFdwXactData(XLogRecPtr lsn, char **buf, int *len);
+static char *ProcessFdwXactBuffer(TransactionId xid, Oid umid,
+								  XLogRecPtr insert_start_lsn, bool fromdisk);
+static char *ReadFdwXactStateFile(TransactionId xid, Oid umid);
+static void RemoveFdwXactStateFile(TransactionId xid, Oid umid, bool giveWarning);
+static void RecreateFdwXactFile(TransactionId xid, Oid umid, void *content, int len);
+
+static FdwXactState insert_fdwxact(Oid dbid, TransactionId xid, Oid umid, Oid serverid,
+								   Oid owner, char *identifier);
+static void remove_fdwxact(FdwXactState fdwxact);
+static List *find_fdwxacts(TransactionId xid, Oid umid, Oid dbid);
+static FdwXactState get_fdwxact_with_check(TransactionId xid, Oid umid,
+										   bool check_two_phase);
+static void pg_foreign_xact_callback(int code, Datum arg);
+
+/*
+ * Calculates the size of shared memory allocated for maintaining foreign
+ * prepared transaction entries.
+ */
+Size
+FdwXactShmemSize(void)
+{
+	Size		size;
+
+	/* Size for foreign transaction information array */
+	size = offsetof(FdwXactCtlData, xacts);
+	size = add_size(size, mul_size(max_prepared_foreign_xacts,
+								   sizeof(FdwXactState)));
+	size = MAXALIGN(size);
+	size = add_size(size, mul_size(max_prepared_foreign_xacts,
+								   sizeof(FdwXactStateData)));
+
+	return size;
+}
+
+/*
+ * Initialization of shared memory for maintaining foreign prepared transaction
+ * entries. The shared memory layout is defined in definition of FdwXactCtlData
+ * structure.
+ */
+void
+FdwXactShmemInit(void)
+{
+	bool		found;
+
+	FdwXactCtl = ShmemInitStruct("Foreign transactions table",
+								 FdwXactShmemSize(),
+								 &found);
+	if (!IsUnderPostmaster)
+	{
+		FdwXactState fdwxacts;
+		int			cnt;
+
+		Assert(!found);
+		FdwXactCtl->free_fdwxacts = NULL;
+		FdwXactCtl->num_xacts = 0;
+
+		/* Initialize the linked list of free FDW transactions */
+		fdwxacts = (FdwXactState)
+			((char *) FdwXactCtl +
+			 MAXALIGN(offsetof(FdwXactCtlData, xacts) +
+					  sizeof(FdwXactState) * max_prepared_foreign_xacts));
+		for (cnt = 0; cnt < max_prepared_foreign_xacts; cnt++)
+		{
+			fdwxacts[cnt].status = FDWXACT_STATUS_INVALID;
+			fdwxacts[cnt].fdwxact_free_next = FdwXactCtl->free_fdwxacts;
+			FdwXactCtl->free_fdwxacts = &fdwxacts[cnt];
+			SpinLockInit(&fdwxacts[cnt].mutex);
+		}
+	}
+	else
+	{
+		Assert(FdwXactCtl);
+		Assert(found);
+	}
+}
 
 /*
  * Register the given foreign transaction participant identified by the
@@ -87,20 +302,21 @@ FdwXactRegisterEntry(UserMapping *usermapping)
 
 	Assert(IsTransactionState());
 
-	if (FdwXactParticipants == NULL)
+	if (DistributedXactState.participants == NULL)
 	{
 		HASHCTL		ctl;
 
 		ctl.keysize = sizeof(Oid);
 		ctl.entrysize = sizeof(FdwXactEntry);
 
-		FdwXactParticipants = hash_create("fdw xact participants",
-										  FDWXACT_HASH_SIZE,
-										  &ctl, HASH_ELEM | HASH_BLOBS);
+		DistributedXactState.participants = hash_create("fdw xact participants",
+														FDWXACT_HASH_SIZE,
+														&ctl, HASH_ELEM | HASH_BLOBS);
 	}
 
 	umid = usermapping->umid;
-	fdwent = hash_search(FdwXactParticipants, (void *) &umid, HASH_ENTER, &found);
+	fdwent = hash_search(DistributedXactState.participants,
+						 (void *) &umid, HASH_ENTER, &found);
 
 	if (found)
 		return;
@@ -124,13 +340,22 @@ FdwXactRegisterEntry(UserMapping *usermapping)
 		ereport(ERROR,
 				(errmsg("cannot register foreign server not supporting transaction callback")));
 
+	fdwent->fdwxact = NULL;
 	fdwent->commit_foreign_xact_fn = routine->CommitForeignTransaction;
 	fdwent->rollback_foreign_xact_fn = routine->RollbackForeignTransaction;
+	fdwent->prepare_foreign_xact_fn = routine->PrepareForeignTransaction;
 
 	MemoryContextSwitchTo(old_ctx);
+
+	/* Update statistics */
+	if (!ServerSupportTwophaseCommit(fdwent))
+		DistributedXactState.nparticipants_no_twophase++;
+
+	Assert(DistributedXactState.nparticipants_no_twophase <=
+		   hash_get_num_entries(DistributedXactState.participants));
 }
 
-/* Remove the foreign transaction from FdwXactParticipants */
+/* Remove the foreign transaction from the current participants */
 void
 FdwXactUnregisterEntry(UserMapping *usermapping)
 {
@@ -145,7 +370,21 @@ FdwXactUnregisterEntry(UserMapping *usermapping)
 static void
 RemoveFdwXactEntry(Oid umid)
 {
-	(void) hash_search(FdwXactParticipants, (void *) &umid, HASH_REMOVE, NULL);
+	FdwXactEntry *fdwent;
+
+	Assert(DistributedXactState.participants != NULL);
+	fdwent = hash_search(DistributedXactState.participants, (void *) &umid,
+						 HASH_REMOVE, NULL);
+
+	if (fdwent)
+	{
+		/* Update statistics */
+		if (!ServerSupportTwophaseCommit(fdwent))
+			DistributedXactState.nparticipants_no_twophase--;
+
+		Assert(DistributedXactState.nparticipants_no_twophase <=
+			   hash_get_num_entries(DistributedXactState.participants));
+	}
 }
 
 /*
@@ -154,29 +393,75 @@ RemoveFdwXactEntry(Oid umid)
 void
 AtEOXact_FdwXact(bool isCommit, bool is_parallel_worker)
 {
-	FdwXactEntry *fdwent;
-	HASH_SEQ_STATUS scan;
-
 	/* If there are no foreign servers involved, we have no business here */
 	if (!HasFdwXactParticipant())
 		return;
 
-	hash_seq_init(&scan, FdwXactParticipants);
-	while ((fdwent = (FdwXactEntry *) hash_seq_search(&scan)))
+	Assert(!RecoveryInProgress());
+
+	if (!isCommit)
 	{
-		Assert(ServerSupportTransactionCallback(fdwent));
+		HASH_SEQ_STATUS scan;
+		FdwXactEntry *fdwent;
 
-		/* Commit or rollback foreign transaction */
-		EndFdwXactEntry(fdwent, isCommit, is_parallel_worker);
+		/* Rollback foreign transactions in the participant list */
+		hash_seq_init(&scan, DistributedXactState.participants);
+		while ((fdwent = (FdwXactEntry *) hash_seq_search(&scan)))
+		{
+			FdwXactState fdwxact = fdwent->fdwxact;
+			int			status;
 
-		/*
-		 * Remove the entry so that we don't recursively process this foreign
-		 * transaction.
-		 */
-		RemoveFdwXactEntry(fdwent->umid);
+			/*
+			 * If this foreign transaction is not prepared yet, end the
+			 * foreign transaction in one-phase.
+			 */
+			if (!fdwxact)
+			{
+				Assert(ServerSupportTransactionCallback(fdwent));
+				EndFdwXactEntry(fdwent, false, is_parallel_worker);
+
+				/*
+				 * Remove FdwXactState entry to prevent processing again in a
+				 * recursive error case.
+				 */
+				RemoveFdwXactEntry(fdwent->umid);
+				continue;
+			}
+
+			/*
+			 * If the foreign transaction has FdwXactState entry, the foreign
+			 * transaction might have been prepared.  We rollback the foreign
+			 * transaction anyway to end the current transaction if the status
+			 * is in-progress.  Since the transaction might have been already
+			 * prepared on the foreign we set the status to aborting and leave
+			 * it.
+			 */
+			SpinLockAcquire(&(fdwxact->mutex));
+			status = fdwxact->status;
+			fdwxact->status = FDWXACT_STATUS_ABORTING;
+			SpinLockRelease(&(fdwxact->mutex));
+
+			if (status == FDWXACT_STATUS_PREPARING)
+				EndFdwXactEntry(fdwent, isCommit, is_parallel_worker);
+		}
 	}
 
-	Assert(!HasFdwXactParticipant());
+	/* Unlock all participants */
+	ForgetAllParticipants();
+
+	/*
+	 * Launch the resolver processes if we failed to prepare the local
+	 * transaction after preparing the foreign transactions.  In this case, we
+	 * need to rollback the prepared transaction on the foreign servers.
+	 */
+	if (DistributedXactState.local_prepared && !isCommit)
+		FdwXactLaunchResolvers();
+
+	/* Reset all fields */
+	DistributedXactState.local_prepared = false;
+	DistributedXactState.nparticipants_no_twophase = 0;
+	list_free(DistributedXactState.serveroids_uniq);
+	DistributedXactState.serveroids_uniq = NIL;
 }
 
 /*
@@ -193,6 +478,7 @@ EndFdwXactEntry(FdwXactEntry *fdwent, bool isCommit, bool is_parallel_worker)
 	finfo.usermapping = fdwent->usermapping;
 	finfo.flags = FDWXACT_FLAG_ONEPHASE |
 		((is_parallel_worker) ? FDWXACT_FLAG_PARALLEL_WORKER : 0);
+	finfo.identifier = NULL;
 
 	if (isCommit)
 	{
